#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=D:\Backup\AutoIT_GIT_24052011_Backup\Eigene Scripte\DR\Charlie-Brown-2.ico
#AutoIt3Wrapper_Outfile=Bestandsliste.exe
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.8.0
 Author:         Dietmar R.    03.03.2012

Script Function: Mini-"Datenbank" zum Hardwarebestand etc. verwalten

	Vielen Dank an  progandy, AutoBert und Raupi fr das Bereitstellen der Funktionen / bzw. Beispiele

#ce ----------------------------------------------------------------------------
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Array.au3> ; fr Array (search/display)
#include <GuiListView.au3> ; fr Listview
#include <ListViewConstants.au3> ; fr Listview sortieren
#include <GuiListBox.au3> ; fr Listbox multiselect
#include <IE.au3> ; fr Bildsuche
#include <GDIPlus.au3> ; fr Bildresize


; ===================================================================
; Variablen  ( incl. Existenz Prfungen Datei/Ordner etc.)
; ===================================================================

Const $SS_REALSIZECONTROL = 0x40   ; Wird fr die Resize Funktion bentigt
Global $Inp_Choose_Dir, $Chk_Backup, $Chk_Question, $Chk_Autofill, $Cbo_Chosse_Combo, $Chk_Proxy, $Inp_Proxy ; Global weil Gui in Funktion somit sonst nicht erreichbar
Global $Lbl_Value_Mod, $Inp_Value_Add, $Btn_Value_Add, $Lbo_Value_Del, $Btn_Value_Del, $Lbl_Value_Add, $Inp_Value_Info

$o_IE = _IECreateEmbedded ()

$f_Data_Dir = @AppDataDir & "\Bestandsliste"
If Not FileExists($f_Data_Dir) Then DirCreate($f_Data_Dir)
If StringRight($f_Data_Dir,1) <> "\" Then $f_Data_Dir &= "\"

$f_Config_Ini = $f_Data_Dir & "Bestandsliste-Config.ini"
If Not FileExists($f_Config_Ini) Then FileInstall("C:\Users\Dietmar\Desktop\Bestandsliste\Bestandsliste-Config.ini",$f_Config_Ini)

$f_Dummy_Pic = $f_Data_Dir & "Dummy.jpg"
If Not FileExists($f_Dummy_Pic) Then FileInstall("C:\Users\Dietmar\Desktop\Bestandsliste\Dummy.jpg",$f_Dummy_Pic)

$a_Ger_Klasse = IniRead($f_Config_Ini,"MenuAuswahl","Gerteklasse","Grafikkarte|Satkarte|Multimediakarte|Soundkarte|Controllerkarte|Arbeitspeicher|CPU|Mainboard|Festplatte|Lfter|Maus|Tastatur|Monitor|Gehuse|Adapter|Zubehr|Kabel|Router|Netzteil")
$a_Ger_Hersteller = IniRead($f_Config_Ini,"MenuAuswahl","Hersteller","Intel|Ati|Nvidia|Kingston|IBM|Adata|Technotrend|Hauppauge|Creative|Adaptec|AMD|Gigabyte|MSI|Asus|Samsung|Hitachi|WesternDigital|Logitech|Microsoft|Cherry|Belinea|TC|Activy|SMT|Bintec|Linksys|Dlink")
$a_Ger_Anschluss = IniRead($f_Config_Ini,"MenuAuswahl","Anschlussart","PCI|AGP|PCI-E|ISA|AT|ATX|ITX|775|2-pol|3-pol|4-pol|USB|PS-2|IDE|SATA|SCSI|E-SATA")
$a_Ger_Anzahl = IniRead($f_Config_Ini,"MenuAuswahl","Anzahl","1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25")

$f_Media_Dir = IniRead($f_Config_Ini,"Einstellungen","Medienverzeichnis","")
If $f_Media_Dir = "" Then
	DirCreate($f_Data_Dir & "Medien")
	IniWrite($f_Config_Ini,"Einstellungen","Medienverzeichnis",$f_Data_Dir & "Medien")
Else
	If Not FileExists($f_Media_Dir) Then
		DirCreate($f_Data_Dir & "Medien")
		MsgBox(0,"Info: ","Altes Medienverzeichnis ist nicht mehr ereichbar." & @CRLF & @CRLF & "Alt: " & $f_Media_Dir & @CRLF & "Neu: " & $f_Data_Dir & "Medien")
		IniWrite($f_Config_Ini,"Einstellungen","Medienverzeichnis",$f_Data_Dir & "Medien")
	EndIf
EndIf
$f_Media_Dir = IniRead($f_Config_Ini,"Einstellungen","Medienverzeichnis","")
If StringRight($f_Media_Dir,1) <> "\" Then $f_Media_Dir &= "\"

$f_Daten_Ini = $f_Media_Dir & "Bestandsliste-Daten.ini"

If IniRead($f_Config_Ini,"Einstellungen","Backup_beim_Start","") = 1 Then
	If Not FileExists($f_Data_Dir & "Backup") Then DirCreate($f_Data_Dir & "Backup")
	If FileExists($f_Daten_Ini) Then FileCopy($f_Daten_Ini, $f_Data_Dir & "Backup\" & @YEAR & "-" & @MON & "-" & @MDAY & "-" & @HOUR & "-" & @MIN & "-" & @SEC & "_Bestandsliste-Daten.ini")
EndIf

$b_Proxy_aktiv = IniRead($f_Config_Ini,"Einstellungen","Proxy_aktiv","")
$s_Proxy_Server = IniRead($f_Config_Ini,"Einstellungen","Proxy_Server","Server:Port")

_Proxy_On_Off($b_Proxy_aktiv,$s_Proxy_Server)


; ===================================================================
; Hauptprogramm: Gui fr Eingabe / Anzeige
; ===================================================================

$_Gui_Main = GUICreate(" Bestandsliste - Erfassung und Anzeige ", 780, 590, -1, -1, -1, $WS_EX_ACCEPTFILES)
	$h_Gui_Main = GUICtrlGetHandle($_Gui_Main)
	$Lbl_Ger_Klasse = GUICtrlCreateLabel("Gerteklasse: ", 40, 27, -1, 25)
	$Cbo_Ger_Klasse = GUICtrlCreateCombo("", 120, 25, 183, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
	GUICtrlSetData(-1,$a_Ger_Klasse)

	$Lbl_Ger_Name = GUICtrlCreateLabel("Gertename: ", 40, 54, -1, 25)
	$Inp_Ger_Name = GUICtrlCreateInput("", 120, 52, 183, 21)

	$Lbl_Ger_Hersteller = GUICtrlCreateLabel("Hersteller: ", 40, 79, -1, 25)
	$Cbo_Ger_Hersteller = GUICtrlCreateCombo("", 120, 77, 183, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
	GUICtrlSetData(-1,$a_Ger_Hersteller)

	$Lbl_Ger_Anschluss = GUICtrlCreateLabel("Anschlussart: ", 40, 106, -1, 25)
	$Cbo_Ger_Anschluss = GUICtrlCreateCombo("", 120, 104, 183, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
	GUICtrlSetData(-1,$a_Ger_Anschluss)

	$Lbl_Ger_Infos = GUICtrlCreateLabel("weitere Infos: ", 40, 133, -1, 25)
	$Inp_Ger_Infos = GUICtrlCreateInput("", 120, 131, 183, 21)

	$Lbl_Ger_Preis = GUICtrlCreateLabel("Preis in Euro: ", 40, 159, -1, 25)
	$Inp_Ger_Preis = GUICtrlCreateInput("", 120, 157, 183, 21)

	$Lbl_Ger_Anzahl = GUICtrlCreateLabel("Anzahl/Menge: ", 40, 186, -1, 25)
	$Cbo_Ger_Anzahl = GUICtrlCreateCombo("", 120, 184, 183, 25)
	GUICtrlSetData(-1,$a_Ger_Anzahl)

	$Lbl_Ger_Bild = GUICtrlCreateLabel("Bilddatei: ", 40, 213, -1, 25)
	$Inp_Ger_Bild = GUICtrlCreateInput("", 120, 211, 183, 21)
	GUICtrlSetState(-1, $GUI_DROPACCEPTED)

	$Btn_Show = GUICtrlCreateButton("Inventar", 324, 25, 65, 25)
	$Btn_Web  = GUICtrlCreateButton("Bildsuche", 324, 52, 65, 25)
	$Btn_Save = GUICtrlCreateButton("Speichern", 324, 85, 65, 25)
	$Btn_Del  = GUICtrlCreateButton("Lschen", 324, 112, 65, 25)
;~ 	$Btn_Zoom = GUICtrlCreateButton("Zoom Bild", 324, 145, 65, 25) ; an dieser Stelle deaktiviert, da nun Klick auf das Bild mglich
	$Btn_Conf = GUICtrlCreateButton("Config", 324, 178, 65, 25)
	$Btn_Info = GUICtrlCreateButton("Hilfe", 324, 208, 65, 25)
	$Pic_Ger  = GUICtrlCreatePic("", 410, 25, 330, 210,$SS_REALSIZECONTROL)
	$Btn_Zoom  = GUICtrlCreatePic("", 460, 30, 270, 200)
	$Lvw_Ger_Liste = GUICtrlCreateListView("Gerteklasse|Gertename|Hersteller|Anschlussart|Infos|Preis|Anzahl|Bildname", 40, 250, 700, 300)

	Global $B_DESCENDING[_GUICtrlListView_GetColumnCount($Lvw_Ger_Liste)] ; fr Sortieren der Listview

GUIRegisterMsg($WM_DROPFILES, "WM_DROPFILES")  ; fr Drag n Drop InputBox incl Leeren
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")  ; fr Doppelklick Listview
GUISetState(@SW_SHOW)


While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			_GUICtrlListView_UnRegisterSortCallBack(GUICtrlGetHandle($Lvw_Ger_Liste))
			Exit

		Case $Lvw_Ger_Liste
            _GUICtrlListView_SimpleSort(GUICtrlGetHandle($Lvw_Ger_Liste), $B_DESCENDING, 0)

		Case $Btn_Show
			_Fill_Listview(GUICtrlRead($Cbo_Ger_Klasse,1),GUICtrlRead($Inp_Ger_Name,1))

		Case $Btn_Web
			_Open_Web_Gui(GUICtrlRead($Cbo_Ger_Klasse,1),GUICtrlRead($Inp_Ger_Name,1))

		Case $Btn_Save
			_Save_Content(GUICtrlRead($Cbo_Ger_Klasse,1),GUICtrlRead($Inp_Ger_Name,1))
			_Fill_Listview(GUICtrlRead($Cbo_Ger_Klasse,1),GUICtrlRead($Inp_Ger_Name,1))

		Case $Btn_Del
			If _Stupid_Question("lschen?","") = "ok" Then
				_Del_Content(GUICtrlRead($Cbo_Ger_Klasse,1),GUICtrlRead($Inp_Ger_Name,1),GUICtrlRead($Inp_Ger_Bild,1))
				_Fill_Listview(GUICtrlRead($Cbo_Ger_Klasse,1),GUICtrlRead($Inp_Ger_Name,1))
			EndIf

		Case $Btn_Zoom
			_Show_Large_Pic(GUICtrlRead($Inp_Ger_Bild,1),GUICtrlRead($Cbo_Ger_Klasse,1))

		Case $Btn_Conf
			_Open_Config_Gui()

		Case $Btn_Info
			MsgBox(0,"Info: ", "Hilfe.....fehlt noch :) ", 5, $_Gui_Main)
	EndSwitch
WEnd


; ===================================================================
; Eigene Funktionen fr Gui etc.
; ===================================================================

Func _Proxy_On_Off($b_Proxy_aktiv,$s_Proxy_Server) ; Proxy_Server nutzen?
	If $b_Proxy_aktiv = 1 Then
		If $s_Proxy_Server <> "" Or $s_Proxy_Server <> "Server:Port" Then HttpSetProxy(2, $s_Proxy_Server)
	Else
		HttpSetProxy(1, $s_Proxy_Server)
	EndIf

	;Proxy setzen
	;~ RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings", "ProxyEnable", "REG_DWORD", "00000001")
	;~ RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings", "ProxyServer", "REG_SZ", "159.148.82.4:3128")
	;Proxy wieder raus nehmen
	;~ RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings", "ProxyEnable", "REG_DWORD", "00000000")
	;~ RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings", "ProxyServer", "REG_SZ", "")
EndFunc

Func _Add_Values_Auto($s_Combo_Target, $s_Combo_Value) ; Fge automatisch beim Datensatz speichern Werte fr Comboboxen hinzu
	If $s_Combo_Value = "" Then
		Return
	Else
		$a_Values_Old = StringSplit(IniRead($f_Config_Ini,"MenuAuswahl",$s_Combo_Target,""),"|")
		_ArraySearch($a_Values_Old,$s_Combo_Value)
		If @error = 6 Then _ArrayAdd($a_Values_Old,$s_Combo_Value)

		$s_Values_New = _ArrayToString($a_Values_Old,"|",1)

		IniWrite($f_Config_Ini,"MenuAuswahl", $s_Combo_Target,$s_Values_New)

		_Refill_Combo($s_Combo_Target, $s_Values_New)
	EndIf
	Return
EndFunc

Func _Refill_Combo($s_Combo_Target, $s_Combo_Value) ; Comboboxen im Hauptprogramm Config nachlesen lassen
	Select
		Case $s_Combo_Target = "Gerteklasse"
			$s_Combo_Target = $Cbo_Ger_Klasse
		Case $s_Combo_Target = "Hersteller"
			$s_Combo_Target = $Cbo_Ger_Hersteller
		Case $s_Combo_Target = "Anschlussart"
			$s_Combo_Target = $Cbo_Ger_Anschluss
		Case $s_Combo_Target = "Anzahl"
			$s_Combo_Target = $Cbo_Ger_Anzahl
	EndSelect

	GUICtrlSetData($s_Combo_Target,"")
	GUICtrlSetData($s_Combo_Target,$s_Combo_Value)
EndFunc

Func _Fill_Listview($s_Ger_Klasse,$s_Ger_Name) ; Flle Listview mit Inhalt (filterbar Typ/Name)
	_GUICtrlListView_DeleteAllItems($Lvw_Ger_Liste)

	If $s_Ger_Klasse <> "" Then
		$a_Ger_Auswahl = IniReadSection($f_Daten_Ini,$s_Ger_Klasse)
		For $i_cnt = 1 To UBound($a_Ger_Auswahl,1) -1
			If $s_Ger_Name <> "" Then
				If Not StringInStr($a_Ger_Auswahl[$i_cnt][0],$s_Ger_Name) Then ContinueLoop
			EndIf
			If Not $a_Ger_Auswahl[$i_cnt][1] = "" Then 	GUICtrlCreateListViewItem($s_Ger_Klasse & "|" & $a_Ger_Auswahl[$i_cnt][0] & "|" & $a_Ger_Auswahl[$i_cnt][1],$Lvw_Ger_Liste)
		Next
	Else
		$a_Klassen_Auswahl = IniReadSectionNames($f_Daten_Ini)
		For $j_cnt = 1 To UBound($a_Klassen_Auswahl,1) -1
			$a_Ger_Auswahl = IniReadSection($f_Daten_Ini,$a_Klassen_Auswahl[$j_cnt])
				For $i_cnt = 1 To UBound($a_Ger_Auswahl,1) -1
					If $s_Ger_Name <> "" Then
						If Not StringInStr($a_Ger_Auswahl[$i_cnt][0],$s_Ger_Name) Then ContinueLoop
					EndIf
						If Not $a_Ger_Auswahl[$i_cnt][1] = "" Then 	GUICtrlCreateListViewItem($a_Klassen_Auswahl[$j_cnt] & "|" & $a_Ger_Auswahl[$i_cnt][0] & "|" & $a_Ger_Auswahl[$i_cnt][1],$Lvw_Ger_Liste)
				Next
		Next
	EndIf

	_GUICtrlListView_RegisterSortCallBack(GUICtrlGetHandle($Lvw_Ger_Liste)) ; fr Sortieren der Listview
EndFunc

Func _Stupid_Question($s_Info_Msg1,$s_Info_Msg2) ; Sicherheitsabfrage (Lschen/Update beim erneuten Speichern)
	If IniRead($f_Config_Ini,"Einstellungen","Sicherheitsabfrage","") = 0 Then Return "ok"
	If Not IsDeclared("iMsgBoxAnswer") Then Local $iMsgBoxAnswer
		$iMsgBoxAnswer = MsgBox(4,"Info:","Mchten Sie wirklich den Datensatz wirklich " & $s_Info_Msg1 & @CRLF & $s_Info_Msg2, Default, $_Gui_Main)
		Select
			Case $iMsgBoxAnswer = 6 ;Yes
				Return "ok"
			Case $iMsgBoxAnswer = 7 ;No
				Return "no"
		EndSelect
EndFunc

Func _Save_Content($s_Ger_Klasse,$s_Ger_Name) ; Speichere Datensatz
	$f_File_Dir = $f_Media_Dir & $s_Ger_Klasse & "\"
	If Not FileExists($f_File_Dir) Then DirCreate($f_File_Dir)

	$s_Ger_Hersteller = GUICtrlRead($Cbo_Ger_Hersteller,1)
	If $s_Ger_Hersteller = "" Then $s_Ger_Hersteller = "#"

	$s_Ger_Anschluss = GUICtrlRead($Cbo_Ger_Anschluss,1)
	If $s_Ger_Anschluss = "" Then $s_Ger_Anschluss = "#"

	$s_Ger_Infos = GUICtrlRead($Inp_Ger_Infos,1)
	If $s_Ger_Infos = "" Then $s_Ger_Infos = "#"

	$s_Ger_Preis = GUICtrlRead($Inp_Ger_Preis,1)
	If $s_Ger_Preis = "" Then $s_Ger_Preis = "#"

	$s_Ger_Anzahl = GUICtrlRead($Cbo_Ger_Anzahl,1)

	$s_Ger_Bild = GUICtrlRead($Inp_Ger_Bild,1)
	If StringInStr($s_Ger_Bild,":\") Then
		$f_File_Ext = StringRight($s_Ger_Bild,4)

		If StringInStr($s_Ger_Bild,$f_Media_Dir) Then
			$s_Ger_Bild = StringTrimLeft($s_Ger_Bild, StringLen($f_File_Dir))
		Else
			FileCopy($s_Ger_Bild,$f_File_Dir & $s_Ger_Name & $f_File_Ext)
			$s_Ger_Bild = $s_Ger_Name & $f_File_Ext
		EndIf
	Else
		If $s_Ger_Bild = "" Or $s_Ger_Bild = "#" Then $s_Ger_Bild = "#"
	EndIf

	If $s_Ger_Klasse <> "" And $s_Ger_Name <> "" And $s_Ger_Anzahl <> "" Then
		$a_Ger_Namen = IniReadSection($f_Daten_Ini,$s_Ger_Klasse)
		_ArraySearch($a_Ger_Namen,$s_Ger_Name)
		If @error Then
			IniWrite($f_Daten_Ini,$s_Ger_Klasse,$s_Ger_Name,$s_Ger_Hersteller & "|" & $s_Ger_Anschluss & "|" & $s_Ger_Infos & "|" & $s_Ger_Preis & "|" & $s_Ger_Anzahl & "|" & $s_Ger_Bild)
		Else
			If _Stupid_Question("speichern?","Der vorhandene Datensatz wird berschrieben!") = "ok" Then
				IniWrite($f_Daten_Ini,$s_Ger_Klasse,$s_Ger_Name,$s_Ger_Hersteller & "|" & $s_Ger_Anschluss & "|" & $s_Ger_Infos & "|" & $s_Ger_Preis & "|" & $s_Ger_Anzahl & "|" & $s_Ger_Bild)
			EndIf
		EndIf
	Else
		MsgBox(0,"Info: ","Datensatz zum Speichern ist nicht vollstndig." & @CRLF & "Gerteklasse und Name und Anzahl sind Pflichtfelder.", Default, $_Gui_Main)
	EndIf

	If IniRead($f_Config_Ini,"Einstellungen","Autofill_ComboBox","") = 1 Then
		_Add_Values_Auto("Gerteklasse",GUICtrlRead($Cbo_Ger_Klasse,1))
		_Add_Values_Auto("Hersteller",GUICtrlRead($Cbo_Ger_Hersteller,1))
		_Add_Values_Auto("Anschlussart",GUICtrlRead($Cbo_Ger_Anschluss,1))
		_Add_Values_Auto("Anzahl",GUICtrlRead($Cbo_Ger_Anzahl,1))
	EndIf
EndFunc

Func _Del_Content($s_Ger_Klasse, $s_Ger_Name,$s_Ger_Bild) ; Lsche Datensatz
	If $s_Ger_Name <> "" Then
		IniDelete($f_Daten_Ini,$s_Ger_Klasse,$s_Ger_Name)
		If FileExists($f_Media_Dir & $s_Ger_Bild) Then FileDelete($f_Media_Dir & $s_Ger_Bild)
		GUICtrlSetData($Inp_Ger_Name,"")
		GUICtrlSetData($Inp_Ger_Bild,"")
		_ImageSetToCtrlREsized($Pic_Ger,$f_Media_Dir & "dummy.jpg", 330, 200)
	EndIf
EndFunc

Func _Open_Web_Gui($s_Ger_Klasse, $s_Ger_Name) ; Neues Fenster fr Online Bildersuche
	If $s_Ger_Name = "" Then
		MsgBox(0,"Info: ",'"Gertename" muss fr die Online-Bildersuche gefllt sein!', Default, $_Gui_Main)
		Return
	EndIf

	Ping("www.google.de")
	If @error Then
		MsgBox(0,"","Keine Internetverbindung vorhanden." & @CRLF & "Nur lokale Bilddateien stehen zur Verfgung.", Default, $_Gui_Main)
		Return
	Else
		$Main_Gui_Pos = WinGetPos(" Bestandsliste - Erfassung und Anzeige ")
		$_Gui_Web = GUICreate(" Bestandsliste - Online Bilderauswahl ", 780, 590, $Main_Gui_Pos[0], $Main_Gui_Pos[1]) ; Gui erzeugen
			$s_IEBrowser = GUICtrlCreateObj($o_IE,5, 5, 770, 530)
			$Btn_Go_Back = GUICtrlCreateButton(" << Suchfenster verlassen ", 150, 545, 220, 30, 0)
			$Btn_Get_Url = GUICtrlCreateButton(" Bild speichern und Suchfenster verlassen ", 400, 545, 220, 30, 0)
			_IENavigate($o_IE,"http://www.google.de/images?q=" & $s_Ger_Klasse & "+" & $s_Ger_Name)
			GUICtrlSetOnEvent($Btn_Go_Back, "_Close_Sub_Gui")
			GUICtrlSetOnEvent($Btn_Get_Url, "_Get_And_Close_WebGui")
	EndIf

	GUISetState()
	Opt("GUIOnEventMode", 1)
EndFunc

Func _Get_And_Close_WebGui() ; Online Bildersuche beenden incl. Bildauswahl speichern
	$f_File_Url = _IEPropertyGet($o_IE,"locationurl")
	$f_File_Ext = StringRight($f_File_Url,4)
	$f_File_Dir = $f_Media_Dir & GUICtrlRead($Cbo_Ger_Klasse,1) & "\"
	If Not FileExists($f_File_Dir) Then DirCreate($f_File_Dir)
	$f_File_Name = $f_File_Dir & GUICtrlRead($Inp_Ger_Name,1) & $f_File_Ext

	InetGet ($f_File_Url, $f_File_Name); [, reload [, background]] )
	GUICtrlSetImage($Pic_Ger, $f_File_Name)
	Sleep(1000)  ; resize

	_ImageSetToCtrlREsized($Pic_Ger, $f_File_Name, 330, 210)  ; resize

	GUISetState(@SW_HIDE)
	Opt("GUIOnEventMode", 0)
	If $f_File_Name <> "" And FileExists($f_File_Name) Then GUICtrlSetData($Inp_Ger_Bild,$f_File_Name)
EndFunc

Func _Show_Large_Pic($s_Ger_Bild, $s_Ger_Klasse) ; Zeige Originalbild an
	If $s_Ger_Bild = "" Or $s_Ger_Klasse = "" Then
		Return
	Else
		If Not StringInStr($s_Ger_Bild,":\") Then
			If FileExists($f_Media_Dir & $s_Ger_Klasse & "\" & $s_Ger_Bild) Then ShellExecute($f_Media_Dir & $s_Ger_Klasse & "\" & $s_Ger_Bild)
		Else
			If FileExists($s_Ger_Bild) Then ShellExecute($s_Ger_Bild)
		EndIf
	EndIf
	Return
EndFunc

Func _Open_Config_Gui() ; Neues Fenster fr Programmeinstellungen
	$Main_Gui_Pos = WinGetPos(" Bestandsliste - Erfassung und Anzeige ")
	$_Gui_Cfg = GUICreate(" Bestandsliste - Konfiguration ", 780, 590, $Main_Gui_Pos[0], $Main_Gui_Pos[1]) ; Gui erzeugen
		$Grp_Config_1 = GUICtrlCreateGroup("Persnliches Medienverzeichnis auswhlen?",5, 15, 770, 520) ; Config 1.Gruppe (Auswahl Medienverzeichnis)
		$Btn_Choose_Dir = GUICtrlCreateButton("...",20,45,21,21)
		GUICtrlSetOnEvent(-1, "_Choose_Media_Dir")
		$Inp_Choose_Dir = GUICtrlCreateInput("",45,45,370,21)
		GUICtrlSetData(-1,$f_Media_Dir)
		$Btn_Media_Dir = GUICtrlCreateButton(" ffne Medienverzeichnis ",440,45,150,21)
		GUICtrlSetOnEvent(-1, "_Open_Media_Dir")
		$Btn_Data_Dir = GUICtrlCreateButton(" ffne Datenverzeichnis ",600,45,150,21)
		GUICtrlSetOnEvent(-1, "_Open_Data_Dir")

		$Grp_Config_2 = GUICtrlCreateGroup("Weitere Einstellungen: ",5,85,770,450) ; Config 2.Gruppe (Weitere Einstellungen mit Checkboxen)
		$Chk_Backup = GUICtrlCreateCheckbox("Daten (ohne Bilder) beim Programmstart sichern?",21,105,-1,21)
		If IniRead($f_Config_Ini,"Einstellungen","Backup_beim_Start","") = 1 Then GUICtrlSetState($Chk_Backup,$GUI_CHECKED)
		$Chk_Question = GUICtrlCreateCheckbox('Sicherheitsbesttigung beim "Speichern / Lschen" erforderlich?',21,130,-1,21)
		If IniRead($f_Config_Ini,"Einstellungen","Sicherheitsabfrage","") = 1 Then GUICtrlSetState($Chk_Question,$GUI_CHECKED)
		$Chk_Autofill = GUICtrlCreateCheckbox('Comboboxeintrge automatisch beim Datensatz speichern hinzufgen?',21,155,-1,21)
		If IniRead($f_Config_Ini,"Einstellungen","Autofill_ComboBox","") = 1 Then GUICtrlSetState($Chk_Autofill,$GUI_CHECKED)

		$Chk_Proxy = GUICtrlCreateCheckbox("Proxy_aktivieren? ",440,105,-1,21) ; Proxy
		If $b_Proxy_aktiv = 1 Then
			If $s_Proxy_Server <> "" And $s_Proxy_Server <> "Server:Port" Then GUICtrlSetState($Chk_Proxy,$GUI_CHECKED)
		Else
			GUICtrlSetState($Chk_Proxy,$GUI_UNCHECKED)
		EndIf
		$Inp_Proxy = GUICtrlCreateInput("",550,105,200,21)
		GUICtrlSetData($Inp_Proxy,$s_Proxy_Server)

		$Grp_Config_3 = GUICtrlCreateGroup("Combobox-Eintrge editieren: ",5,205,770,330) ; Config 3.Gruppe (Edit Comboxen)
		$Lbl_Edit_Combo = GUICtrlCreateLabel("Welche Combobox-Eintrge sind anzupassen?",20,227,-1,21)
		$Cbo_Chosse_Combo = GUICtrlCreateCombo("",20,247, 220,21)
		GUICtrlSetData(-1,"Gerteklasse|Hersteller|Anschlussart|Anzahl","Gerteklasse")
		$Btn_Chombo_Add = GUICtrlCreateButton(" Combobox Werte hinzufgen ",20,275, 220,21)
		GUICtrlSetOnEvent(-1, "_Show_Config_Add")
		$Btn_Chombo_Del = GUICtrlCreateButton(" Combobox Werte entfernen ",20,300, 220,21)
		GUICtrlSetOnEvent(-1, "_Show_Config_Del")

		$Lbl_Value_Mod = GUICtrlCreateLabel("",280,227,480,21) ; Config  (Dynamisches Men Hinzufgen/Entfernen)
		$Inp_Value_Add = GUICtrlCreateInput("",280,247, 220,21) ; Hinzufgen
		GUICtrlSetState(-1,$GUI_HIDE)
		$Lbl_Value_Add = GUICtrlCreateLabel(" Momentan hinterlegte Werte:",280,285, -1, 21)
		GUICtrlSetState(-1,$GUI_HIDE)
		$Inp_Value_Info = GUICtrlCreateEdit("",280,305, 470,100,BitOr($ES_READONLY, $ES_MULTILINE))
		GUICtrlSetState(-1,$GUI_HIDE)
		$Btn_Value_Add = GUICtrlCreateButton(" Neue Werte speichern! ",530,247, 220,21)
		GUICtrlSetState(-1,$GUI_HIDE)
		GUICtrlSetOnEvent($Btn_Value_Add, "_Add_Values")

		$Lbo_Value_Del = GUICtrlCreateList("",280,247, 220,240,BitOr($LBS_SORT, $WS_HSCROLL, $WS_VSCROLL, $WS_BORDER, $LBS_MULTIPLESEL)) ; Entfernen
		GUICtrlSetState(-1,$GUI_HIDE)
		$Btn_Value_Del = GUICtrlCreateButton(" Markierte Werte lschen! ",530,247, 220,21)
		GUICtrlSetState(-1,$GUI_HIDE)
		GUICtrlSetOnEvent($Btn_Value_Del, "_Del_Values")

		$Btn_Go_Back = GUICtrlCreateButton(" << Konfiguration verlassen ", 150, 545, 220, 30, 0) ; Config (speichern und )verlassen
		GUICtrlSetOnEvent(-1, "_Close_Sub_Gui")
		$Btn_Get_Url = GUICtrlCreateButton(" Konfiguration speichern und verlassen ", 400, 545, 220, 30, 0)
		GUICtrlSetOnEvent(-1, "_Save_And_Close_ConfigGui")

	GUISetState()
	Opt("GUIOnEventMode", 1)
EndFunc

Func _Choose_Media_Dir() ; Ordner suchen Dialog fr Medienverzeichnisauswahl
	$var = FileSelectFolder("Choose a folder.", "")
	If $var <> "" And FileExists($var) Then GUICtrlSetData($Inp_Choose_Dir, $var)
EndFunc

Func _Open_Media_Dir() ; ffne Ordner Media
	Run(@WindowsDir & "\explorer.exe /e, /root, " & $f_Media_Dir)
	Return
EndFunc

Func _Open_Data_Dir() ; ffne Ordner Appdata
	Run(@WindowsDir & "\explorer.exe /e, /root, " & $f_Data_Dir)
	Return
EndFunc

Func _Show_Config_Add() ; Aktiviere Hinzufgen Auswahl
	GUICtrlSetData($Inp_Value_Info,"")
	GUICtrlSetData($Inp_Value_Info,StringReplace(IniRead($f_Config_Ini,"MenuAuswahl",GUICtrlRead($Cbo_Chosse_Combo,1),""),"|"," "))
	GUICtrlSetData($Lbl_Value_Mod," Neue Werte hinzufgen:  (Bitte bei Eingabe multipler Werte, diese dann durch ein Komma trennen.)")

	GUICtrlSetState($Lbo_Value_Del,$GUI_HIDE) ; ausblenden
	GUICtrlSetState($Btn_Value_Del,$GUI_HIDE)
	GUICtrlSetState($Inp_Value_Add,$GUI_SHOW) ; einblenden
	GUICtrlSetState($Btn_Value_Add,$GUI_SHOW)
	GUICtrlSetState($Lbl_Value_Add,$GUI_SHOW)
	GUICtrlSetState($Inp_Value_Info,$GUI_SHOW)
EndFunc

Func _Show_Config_Del() ; Aktiviere Entfernen Auswahl
	GUICtrlSetData($Lbo_Value_Del,"")
	GUICtrlSetData($Lbo_Value_Del,IniRead($f_Config_Ini,"MenuAuswahl",GUICtrlRead($Cbo_Chosse_Combo,1),""))
	GUICtrlSetData($Lbl_Value_Mod," Werte zum Entfernen markieren: (Multiselect)")

	GUICtrlSetState($Inp_Value_Add,$GUI_HIDE) ; ausblenden
	GUICtrlSetState($Btn_Value_Add,$GUI_HIDE)
	GUICtrlSetState($Lbl_Value_Add,$GUI_HIDE)
	GUICtrlSetState($Inp_Value_Info,$GUI_HIDE)
	GUICtrlSetState($Lbo_Value_Del,$GUI_SHOW) ; einblenden
	GUICtrlSetState($Btn_Value_Del,$GUI_SHOW)
EndFunc

Func _Add_Values() ; Fge Werte fr Comboboxen hinzu
	$a_Values_Old = StringSplit(IniRead($f_Config_Ini,"MenuAuswahl",GUICtrlRead($Cbo_Chosse_Combo,1),""),"|")

	$s_Values_Add =	GUICtrlRead($Inp_Value_Add,1)
	If StringInStr($s_Values_Add,",") Then
		$a_Values_Add = StringSplit($s_Values_Add,",")
		For $i_val_cnt = 1 To UBound($a_Values_Add,1) -1
			_ArraySearch($a_Values_Old,$a_Values_Add[$i_val_cnt])
			If @error = 6 Then _ArrayAdd($a_Values_Old,$a_Values_Add[$i_val_cnt])
		Next
	Else
		_ArraySearch($a_Values_Old,$s_Values_Add)
		If @error = 6 Then _ArrayAdd($a_Values_Old,$s_Values_Add)
	EndIf

	$s_Values_New = _ArrayToString($a_Values_Old,"|",1)

	IniWrite($f_Config_Ini,"MenuAuswahl", GUICtrlRead($Cbo_Chosse_Combo,1),$s_Values_New)
	GUICtrlSetData($Inp_Value_Info,"")
	GUICtrlSetData($Inp_Value_Info,StringReplace($s_Values_New,"|"," "))

	_Refill_Combo(GUICtrlRead($Cbo_Chosse_Combo,1), $s_Values_New)

	Return
EndFunc

Func _Del_Values() ; Entferne Werte fr Comboboxen
	$a_Values_Old = StringSplit(IniRead($f_Config_Ini,"MenuAuswahl",GUICtrlRead($Cbo_Chosse_Combo,1),""),"|")
	_ArraySort($a_Values_Old,0)

	$a_Values_Del = _GUICtrlListBox_GetSelItems($Lbo_Value_Del)
	For $i_val_cnt = UBound($a_Values_Del,1) -1 to 1 Step -1
		_ArrayDelete($a_Values_Old,$a_Values_Del[$i_val_cnt] + 1)
	Next

	$s_Values_New = _ArrayToString($a_Values_Old,"|",1)

	IniWrite($f_Config_Ini,"MenuAuswahl", GUICtrlRead($Cbo_Chosse_Combo,1),$s_Values_New)
	GUICtrlSetData($Lbo_Value_Del,"")
	GUICtrlSetData($Lbo_Value_Del,$s_Values_New)

	_Refill_Combo(GUICtrlRead($Cbo_Chosse_Combo,1), $s_Values_New)

	Return
EndFunc

Func _Save_And_Close_ConfigGui() ; Programmeinstellungen verlassen incl. speichern
	$f_Tmp_Dir = GUICtrlRead($Inp_Choose_Dir,1)
	If  $f_Tmp_Dir <> $f_Media_Dir Then
		FileMove($f_Media_Dir,$f_Tmp_Dir)
		$f_Media_Dir = $f_Tmp_Dir
		If StringRight($f_Media_Dir,1) <> "\" Then $f_Media_Dir &= "\"
		IniWrite($f_Config_Ini,"Einstellungen","Medienverzeichnis",$f_Media_Dir)
		$f_Daten_Ini = $f_Media_Dir & "Bestandsliste-Daten.ini"
	EndIf

	If GUICtrlRead($Chk_Backup) = 1 Then
		IniWrite($f_Config_Ini,"Einstellungen","Backup_beim_Start",1)
	Else
		IniWrite($f_Config_Ini,"Einstellungen","Backup_beim_Start",0)
	EndIf

	If GUICtrlRead($Chk_Question) = 1 Then
		IniWrite($f_Config_Ini,"Einstellungen","Sicherheitsabfrage",1)
	Else
		IniWrite($f_Config_Ini,"Einstellungen","Sicherheitsabfrage",0)
	EndIf

	If GUICtrlRead($Chk_Autofill) = 1 Then
		IniWrite($f_Config_Ini,"Einstellungen","Autofill_ComboBox",1)
	Else
		IniWrite($f_Config_Ini,"Einstellungen","Autofill_ComboBox",0)
	EndIf

	$b_Proxy_aktiv = GUICtrlRead($Chk_Proxy)
	$s_Proxy_Server = GUICtrlRead($Inp_Proxy,1)

	If  $b_Proxy_aktiv = 1 Then
		IniWrite($f_Config_Ini,"Einstellungen","Proxy_aktiv",1)
	Else
		IniWrite($f_Config_Ini,"Einstellungen","Proxy_aktiv",0)
	EndIf

	If  $s_Proxy_Server = "" Then
		IniWrite($f_Config_Ini,"Einstellungen","Proxy_Server","Server:Port")
	Else
		IniWrite($f_Config_Ini,"Einstellungen","Proxy_Server",$s_Proxy_Server)
	EndIf

	_Proxy_On_Off($b_Proxy_aktiv,$s_Proxy_Server)

	GUISetState(@SW_HIDE)
	Opt("GUIOnEventMode", 0)
EndFunc

Func _Close_Sub_Gui() ; Einstellungen / Webgui ohne Speichern verlassen
	GUISetState(@SW_HIDE)
	Opt("GUIOnEventMode", 0)
EndFunc


; ===================================================================
; Erweiterte Funktionen bzw. Anregungen aus dem AutoIt-Forum:
; Vielen Dank an  progandy, AutoBert und Raupi
;	http://autoit.de/index.php?page=Thread&postID=49610#post49610
;	http://www.autoit.de/index.php?page=Thread&postID=178136#post178136
;	http://autoit.de/index.php?page=Thread&postID=213177#post213177
; ===================================================================

Func _ImageSetToCtrlREsized($CtrlID,$FileName,$size_x,$size_y) ; Bild fr Anzeige resizen (png gelegentlich problematisch)
	_GDIPlus_Startup()
	Local $hImg = _GDIPlus_ImageLoadFromFile($FileName)
	Local $w = _GDIPlus_ImageGetWidth($hImg)
	Local $h = _GDIPlus_ImageGetHeight($hImg)
	_GDIPlus_ImageDispose($hImg)
	_GDIPlus_Shutdown()

;~ 	; Hhe / Breite berechnen: max. 330x210
	$calcx = $w/($h/210)
	$calcy = 210

	If $calcx > 330 Then
		$calcy = $calcy /($calcx/330)
		$calcx = 330
	EndIf

	ControlMove(_WinAPI_GetParent(GUICtrlGetHandle($CtrlID)),"",$CtrlID,410 + (330-$calcx),Default,$calcx,$calcy)
	GUICtrlSetImage($CtrlID,$FileName)
EndFunc

Func WM_NOTIFY($hWnd, $MsgID, $wParam, $lParam) ; Notify fr Listview (Rckbefllen der Eingabefelder aus Listbox bei Klick)
    Local $tagNMHDR, $event, $hwndFrom, $code
    $tagNMHDR = DllStructCreate("int;int;int", $lParam)
    If @error Then Return 0
    $code = DllStructGetData($tagNMHDR, 3)
    If $wParam = $Lvw_Ger_Liste Then
        ConsoleWrite($code & @CRLF)
        Switch $code
            Case -2 ;Klick
;~             Case -3 ;Doppelklick
                If _GUICtrlListView_GetSelectedCount($Lvw_Ger_Liste) > 0 Then
                    For $i = 0 To _GUICtrlListView_GetItemCount($Lvw_Ger_Liste)
                        If _GUICtrlListView_GetItemSelected($Lvw_Ger_Liste, $i) Then
                            $aItem = _GUICtrlListView_GetItemTextArray($Lvw_Ger_Liste, $i)
							GUICtrlSetData($Cbo_Ger_Klasse,$aItem[1])
							GUICtrlSetData($Inp_Ger_Name,$aItem[2])
							GUICtrlSetData($Cbo_Ger_Hersteller,$aItem[3])
							GUICtrlSetData($Cbo_Ger_Anschluss,$aItem[4])
							GUICtrlSetData($Inp_Ger_Infos,$aItem[5])
							GUICtrlSetData($Inp_Ger_Preis,$aItem[6])
							GUICtrlSetData($Cbo_Ger_Anzahl,$aItem[7])
							GUICtrlSetData($Inp_Ger_Bild,$aItem[8])
   							If FileExists($f_Media_Dir & $aItem[1] & "\" & $aItem[8]) Then
								_ImageSetToCtrlREsized($Pic_Ger, $f_Media_Dir & $aItem[1] & "\" & $aItem[8], 330, 210)
							Else
								_ImageSetToCtrlREsized($Pic_Ger, $f_Dummy_Pic, 330, 210)
							EndIf
						EndIf
                    Next
                EndIf
        EndSwitch
    EndIf
    Return $GUI_RUNDEFMSG
EndFunc

Func WM_DROPFILES($hWnd, $msgID, $wParam, $lParam) ; Korrektur der Drap n Drop Funktion (vorhandenen Wert entfernen)
	GUICtrlSetData($Inp_Ger_Bild, "")
    Return $GUI_RUNDEFMSG
EndFunc
